@echo off
if /i exist "%~nx0" color 40 && echo. && echo. && echo 벻Ҫִбļ && echo. && echo 밴˳ && pause>nul && exit

:doFactoryReset
set /A failure_count=0

    if "%device_is_qcom%" EQU "1" (
        goto :doEraseQCOMRelatedPT
    )
    goto :skipEraseQCOMRelatedPT

    :doEraseQCOMRelatedPT

    if "%device_has_ddr%" EQU "1" (
        echo.
        echo ------  DDR  ------
        %fastboot% -s %serial_number% erase ddr
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo ʾfastboot  ddr ʧܣ
            echo ------------------------------
        )
    )

    if "%device_has_oldddr%" EQU "1" (
        echo.
        echo ------  DDR  ------
        %fastboot% -s %serial_number% erase DDR
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo ʾfastboot  DDR ʧܣ
            echo ------------------------------
        )
    )

    :skipEraseQCOMRelatedPT

    if "%device_has_carrier%" EQU "1" (
        echo.
        echo ------  Carrier  ------
        %fastboot% -s %serial_number% erase carrier
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo ʾfastboot  carrier ʧܣ
            echo ------------------------------
        )
    )

    if "%device_has_cache%" EQU "1" (
        echo.
        echo ------  Cache  ------
        %fastboot% -s %serial_number% erase cache
        if %errorlevel% NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo fastboot  cache ʧܣ
            echo ------------------------------
        )
    )

    echo.
    echo ------  Userdata  ------
    %fastboot% -s %serial_number% erase userdata
    if %errorlevel% NEQ 0 (
        color fc
        echo ------------------------------
        echo شfastboot  userdata ʧܣ
        echo ------------------------------
        exit /b 1
    )

    if "%device_has_customize%" EQU "1" (
        echo.
        echo ------  Customize  ------
        %fastboot% -s %serial_number% erase customize
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo ʾfastboot  customize ʧܣ
            echo ------------------------------
        )
    )

    if "%device_has_clogo%" EQU "1" (
        echo.
        echo ------  Clogo  ------
        %fastboot% -s %serial_number% erase clogo
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo ʾfastboot  clogo ʧܣ
            echo ------------------------------
        )
    )

    REM only MTK or pre-installed android 10+ devices can erase metadata partition
    if "%device_has_preloader%" EQU "1" (
        goto :doEraseMetadata
    )
    if "%device_has_super%" EQU "1" (
        goto :doEraseMetadata
    )
    goto :skipEraseMetadata

    :doEraseMetadata
    if "%device_has_metameta%" EQU "1" (
        echo.
        echo ------  Metadata  ------
        %fastboot% -s %serial_number% erase metadata
        if !errorlevel! NEQ 0 (
            color f6
            set /A failure_count+=1
            echo ------------------------------
            echo ʾfastboot  metadata ʧܣ
            echo ------------------------------
        )
    )
    :skipEraseMetadata

exit /b 0
