@echo off
@SETLOCAL enabledelayedexpansion
if /i exist "%~nx0" color 40 && echo. && echo. && echo 벻Ҫִбļ && echo. && echo 밴˳ && pause>nul && exit

:runUnlockBL
color f9
@title %title% %version% -  Bootloader [%serial_number%]

    if "%1" == "" (
        color fc
        echo.
        echo شѡΪգ
        goto :tips
    ) else (
        set unlock_option=%1
    )

    REM call "%~dp0getPartitionTable.cmd"

    if "%unlock_option%" == "1" call :doUnlockFlashingBL
    if "%unlock_option%" == "2" call doUnlockOemBL
    if "%unlock_option%" == "3" call :doUnlockOemMotoBL
    if "%unlock_option%" == "4" call :runGetUnlockData

    if %errorlevel% NEQ 0 (
        echo.
        echo 豸 [%serial_number%] ʧܡ
    ) else (
        color f2
        echo.
        echo 豸 [%serial_number%] ɡ
    )

    if "%device_count%" NEQ "1" (
        goto :tips
    )

exit /b 0
::
::
:doUnlockFlashingBL
@title %title% %version% -  Bootloader [%serial_number%]
    echo.
    echo ִУ fastboot -s %serial_number% flashing unlock
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% flashing unlock 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=*" %%C in (`echo %%X ^| %%grep%% -i -c "unlocked"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )
    REM string "unlocked" occurrence count 
    if %okay_count% == 0 (
        color fc
        echo ---------------------------
        echo 󣺽 Bootloader ʧܣ
        echo ---------------------------
        exit /b 1
    )

    color f2
    echo.
    echo ɹBootloader ѽ

exit /b 0
::
::
:doUnlockOemMotoBL
@title %title% %version% -  Motorola Bootloader [%serial_number%]
    echo.
    echo. [-] ʾ [%serial_number%] Ľ룬س
    echo. [-] 磺DVNJ6NFFT2MLEZABQ4FQ
    echo.
    set unlockcode=
    set /p unlockcode= Ѵ Motorola վȡĽ벢س ^>^>
        if "%unlockcode%"=="" (
            echo 롣
            ping 127.0.1 -n 2 >nul 2>nul
            cls && goto :doUnlockOemMotoBL
        )

    echo.
    echo ִУ fastboot -s %serial_number% oem unlock %unlockcode%
    %fastboot% -s %serial_number% oem unlock %unlockcode%
    REM Confirm unlock again
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% oem unlock %%unlockcode%% 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=*" %%C in (`echo %%X 2^>^&1 ^| %%grep%% -i -c "unlocked"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )
    REM string "unlocked" occurrence count 
    if %okay_count% == 0 (
        color fc
        echo ---------------------------
        echo 󣺽 Bootloader ʧܣ
        echo ---------------------------
        exit /b 1
    )

    color f2
    echo.
    echo ɹBootloader ѽ

exit /b 0
::
::
:runGetUnlockData
@title %title% %version% - ȡ豸 ID [%serial_number%]

    echo.
    echo ȡ [%serial_number%] Ľݣ
    echo.
    call "%~dp0doGetUnlockData.cmd"
    if %errorlevel% NEQ 0 (
        echo.
        echo ȡʧܣ
        goto :tips
    )

    echo %ULKData%

    if %device_count% == 1 (
        REM do not try to format this line
        echo %ULKData%| clip
        echo.
        echo 豸 ID ѾƵ塣
    )

    if %device_count% NEQ 1 (
        echo.
        echo дļUnlockData_%serial_number%.txt
        echo %ULKData% > UnlockData_%serial_number%.txt
        goto :tips
    )

exit /b 0
::
::
:doUnlockOemBL
@title %title% %version% -  Bootloader [%serial_number%]
    echo.
    echo ִУ fastboot -s %serial_number% oem unlock
    set /A okay_count=0

    for /F "usebackq tokens=*" %%X in (`%%fastboot%% -s %%serial_number%% oem unlock 2^>^&1`) do (
        echo %%X
        for /F "usebackq tokens=1" %%C in (`echo %%X ^| %%grep%% -i -c "unlocked"`) do (
            if "%%C" == "1" set /A okay_count+=1
        )
    )
    REM string "unlocked" occurrence count 
    if %okay_count% == 0 (
        color fc
        echo ---------------------------
        echo 󣺽 Bootloader ʧܣ
        echo ---------------------------
        exit /b 1
    )

    color f2
    echo.
    echo ɹBootloader ѽ

exit /b 0
::
::
:tips
    echo.
    echo 밴˳
    pause > nul
::
::
:exit
exit
